#include "base.h"
#include "win32_platform.h"
#include "arena.h"
#include "string.h"
#include "hash_store.h"

#include "win32_platform.c"
#include "arena.c"
#include "string.c"
#include "hash_store.c"

int
main(void)
{
  Table *table = hash_store_initialize();

  String8 str8_1 = str8_lit("Hello world");
  String8 str8_2 = str8_lit("ayenooo");

  Key key1 = hash_store_string8_to_key(table, str8_1);
  Key key2 = hash_store_string8_to_key(table, str8_2);
  Key key3 = hash_store_string8_to_key(table, str8_1);

  String8 string = hash_store_string8_from_key(table, key2);
  printf("%.*s\n", (i32) string.length, string.content);

  return 0;
};
